function ad2ToFits, ad2, fits, hdr
COMPILE_OPT IDL2
  if n_params() eq 0 then begin
    print, 'Syntax: ad2ToFits(ad2, fits, hdr)'
    print, '     ad2 - ad2 file(s) to read from'
    print, '    fits - fits file(s) to write to'
    print, '     hdr - fits header(s) to append ad2 trailer to'
    return, -1
  endif

  if n_elements(fits) eq 0 then begin
    fits = strarr(n_elements(ad2))
    for i=0, n_elements(ad2)-1 do begin
      test = strsplit(ad2[i], '.')
      fits[i] = string((byte(ad2[i]))[0:test[n_elements(test)-1]-2]) + '.fits'
    endfor
  endif

  n = n_elements(ad2)<n_elements(fits)
  n = (n_elements(hdr) le 1)?n:n<n_elements(hdr)
  success = 0

  for i=0, n-1 do begin

    im = readad2(ad2[i], trailer)

    if (n_elements(im) eq 1) and (im[0] eq -1) then continue

    if n_elements(hdr) gt 1 then begin
      h = ad2TrailerToFitsHeader(trailer, hdr[i])
    endif else begin
      h = ad2TrailerToFitsHeader(trailer, hdr)
    endelse

    idx = where(im lt !values.f_infinity)

    if idx[0] ne -1 then begin
      idx1 = where(im[idx] gt -3.1E+38)
      if idx1[0] ne -1 then begin
        mm = minmax(im[idx[idx1]])
        sxaddpar, h, 'datamax', mm[1]
        sxaddpar, h, 'datamin', mm[0]
      endif
    endif

    writefits, fits[i], im, h

    success = success+1
  endfor

  return, success
end
