function ad3ToFits, ad3, fits, hdr, fits_xyz=fx
COMPILE_OPT IDL2
  if n_params() eq 0 then begin
    print, 'Syntax: ad3ToFits(ad3, fits, hdr, fits_xyz=fx)'
    print, '     ad3 - ad3 file(s) to read from'
    print, '    fits - fits file(s) to write to'
    print, '     hdr - fits header(s) to append ad3 trailer to'
    print, 'fits_xyz - 0: Write fits in zxy format'
    print, '           1: Write fits in xyz format'
    print, '           Default: 1'
    return, -1
  endif

  if n_elements(fx) eq 0 then fx = 1

  if n_elements(fits) eq 0 then begin
    fits = strarr(n_elements(ad3))
    for i=0, n_elements(ad3)-1 do begin
      test = strsplit(ad3[i], '.')
      fits[i] = string((byte(ad3[i]))[0:test[n_elements(test)-1]-2]) + '.fits'
    endfor
  endif

  n = (n_elements(fits) gt 0)?n_elements(ad3)<n_elements(fits):n_elements(ad3)
  n = (n_elements(hdr) le 1)?n:n<n_elements(hdr)
  success = 0

  for i=0, n-1 do begin

    im = readad3(ad3[i], trailer, xyz=fx)

    if fx eq 0 then begin
      trailer.nbdim = 3
    endif else begin
      trailer.nbdim = -3
    endelse

    if (n_elements(im) eq 1) and (im[0] eq -1) then continue

    if n_elements(hdr) gt 1 then begin
      h = ad3TrailerToFitsHeader(trailer, hdr[i])
    endif else begin
      h = ad3TrailerToFitsHeader(trailer, hdr)
    endelse

    writefits, fits[i], im, h

    success = success+1
  endfor

  return, success
end
