pro adCoordinates, ad, star1=s1, pos1=p1, star2=s2, pos2=p2, equinox=equinox
COMPILE_OPT IDL2

  data = readad(ad, trailer, xyz=0)

  sz = size(data)

  im = (sz[0] eq 3)?total(data, 1):data

;  im = rot(im, 30)

  sz = size(im)

  window, 0, xsize=sz[1], ysize=sz[2]

  tvscl, rescale(im, 0.01, 0.99)

  if n_elements(s1) ne 2 then begin
    print, 'Clic on first reference star'
    cursor, x, y, /device, /up
    s1 = double([x,y])
  endif
  x = s1[0]
  y = s1[1]

  print, '(' + strtrim(x,2) + ', ' + strtrim(y,2) + ')'
  cntrd, im, x, y, xcen, ycen, 10
  print, '(' + strtrim(x,2) + ', ' + strtrim(y,2) + ') --> (' + strtrim(xcen,2) + ', ' + strtrim(ycen,2) + ')'
  tvcircle, 10, round(xcen), round(ycen)

  s1[0]=xcen
  s1[1]=ycen

  if n_elements(p1) ne 2 then begin
    get_coords, p1, 'Type in RA and DEC of first star'
    p1 = double(p1)
    p1[0] = p1[0]*15.0
  endif

  if n_elements(s2) ne 2 then begin
    print, 'Clic on second reference star'
    cursor, x, y, /device, /up
    s2 = double([x,y])
  endif
  x = s2[0]
  y = s2[1]

  print, '(' + strtrim(x,2) + ', ' + strtrim(y,2) + ')'
  cntrd, im, x, y, xcen, ycen, 10
  print, '(' + strtrim(x,2) + ', ' + strtrim(y,2) + ') --> (' + strtrim(xcen,2) + ', ' + strtrim(ycen,2) + ')'
  tvcircle, 10, round(xcen), round(ycen)

  s2[0]=xcen
  s2[1]=ycen

  if n_elements(p2) ne 2 then begin
    get_coords, p2, 'Type in RA and DEC of second star'
    p2 = double(p2)
    p2[0] = p2[0]*15.0  
  endif

  if n_elements(equinox) ne 1 then begin
    read, 'Type in equinox for coordinates: ', equinox
    equinox = float(equinox)
  endif

  print, p1, p2, s1, s2

  degra = !dpi/180.0d

  a1 = p1[0]*degra
  a2 = p2[0]*degra
  d1 = p1[1]*degra
  d2 = p2[1]*degra

  x1 = s1[0]
  y1 = s1[1]
  x2 = s2[0]
  y2 = s2[1]

;  distanceCoord = sqrt(((p1[0]-p2[0])*cos(p1[1]))^2 + (p1[1]-p2[1])^2)
;  distanceCoord = sqrt(((p1[0]-p2[0]))^2 + (p1[1]-p2[1])^2)
;  distanceCoord = acos(sin(p1[1])*sin(p2[1])+cos(p1[1])*cos(p2[1])*cos(p1[0]-p2[0]))
;  distanceCoord = sqrt(((p1[0]-p2[0])*cos((p1[1]+p2[1])/2))^2 + (p1[1]-p2[1])^2)

  ; Calculate distance in degrees between two stars:
  ; Taken from astronomical algorythms, p.115
  a = cos(d1)*sin(d2)-sin(d1)*cos(d2)*cos(a2-a1)
  b = cos(d2)*sin(a2-a1)
  c = sin(d1)*sin(d2)+cos(d1)*cos(d2)*cos(a2-a1)

  distanceCoord = atan(sqrt(a^2+b^2)/c)/degra
  
  distancePix = sqrt((s1[0]-s2[0])^2 + (s1[1]-s2[1])^2)

  scale = (distanceCoord/distancePix)

  posang, 1, p1[0]/15.d, p1[1], p2[0]/15.d, p2[1], angCoord

; Si on tourne le systeme de coordonnees (x,y) de -PA,
; on trouvera la position du nord en regardant la position du point 1 
; par rapport au point 2
  angCoord = (angCoord lt 0)?angCoord+360:angCoord
  angCoord = angCoord*degra
  ; Si posang == 0:   etoile 2 au nord de l'etoile 1
  ; Si posang == 90:  etoile 2 a l'est de l'etoile 1
  ; Si posang == 180: etoile 2 au sud de l'etoile 1
  ; Si posang == 270: etoile 2 a l'ouest de l'etoile 1

;  angPix = atan((s2[0]-s1[0]) / (s2[1]-s1[1]))
  angPix = atan((y1-y2) / (x1-x2))
  ; Test 2e quadran
  angPix = (((x1-x2) gt 0) and ((y1-y2) lt 0))?angPix+!dpi:angPix
  ; Test 3e quadran
  angPix = (((x1-x2) gt 0) and ((y1-y2) gt 0))?angPix+!dpi:angPix
  angPix = !dpi/2.0d - angPix

  ; Si on tourne le systeme de coordonnees (x,y) de -PA,
  ; on trouvera la position du nord en regardant la position du point 1 
  ; par rapport au point 2

  xr2 = distancePix*cos(angPix-angCoord)+x1
  yr2 = distancePix*sin(angPix-angCoord)+y1
  
  northAngle = atan((y1-yr2) / (x1-xr2))
  ; Test 2e quadran
  northAngle = (((x1-xr2) gt 0) and ((y1-yr2) lt 0))?northAngle+!dpi:northAngle
  ; Test 3e quadran
  northAngle = (((x1-xr2) gt 0) and ((y1-yr2) gt 0))?northAngle+!dpi:northAngle

  yn2 = distancePix*sin(!dpi/2.0d + angpix - angcoord - northAngle)+y1
  ; Si le point 2 tombe au-dessus de
  ; nous, et que sa declinaison est plus grande que celle du point 1, 
  ; le nord est bien en haut
  y_mirror = ((yn2 gt y1) and (d2 gt d1))?1:-1

  ; On tourne le referentiel a l'est
  xn2 = distancePix*cos(angpix - angcoord - northAngle)+x1 
  ; Si le point 2 tombe a gauche du
  ; point 1 et que son AD est plus grande que celle du point 1, l'est
  ; est bien a gauche
  x_mirror = ((xn2 gt x1) and (a2 gt a1) and (abs(a2 - a1) le 12))?1:-1

  rotation = northAngle/degra

  print, rotation, x_mirror, y_mirror
  
  trailer.crval1 = p1[0]
  trailer.crval2 = p1[1]
  trailer.crpix1 = s1[0]+1  ; Pixel values start at (1,1)
  trailer.crpix2 = s1[1]+1
  trailer.equinox = equinox
  trailer.crota1 = rotation
  trailer.x_mirror = (x_mirror eq -1)?1:0
  trailer.y_mirror = (y_mirror eq -1)?1:0
  trailer.scale = scale*3600.0
  trailer.cdelta = scale

;  trailer.crval1 = 0
;  trailer.crval2 = 0
;  trailer.crpix1 = 1  ; Pixel values start at (1,1)
;  trailer.crpix2 = 1
;  trailer.equinox = equinox
;  trailer.crota1 = 0
;  ; Normalement, l'est est a droite et l'ouest a gauche. On veut le contraire
;  trailer.x_mirror = (x_direction eq -1)?0:1
;  trailer.y_mirror = (y_direction eq -1)?1:0
;  trailer.scale = 3600.0
;  trailer.cdelta = 1.0

;  print, 'Warning: writing im instead of data!'
  toto = writead(ad, data, trailer, data_xyz=0)

end
