function align, cube, offset, validCalib, sky_flat=skyf, map_sky_flat=skyflat, resolution=res, raw=centrepos, plot=p, region=reggood, continumflat=cf, ohmap=ohmap, skyzone=skyzone, pass=pass, alignthreshold=ath, maxlag=maxalign
COMPILE_OPT IDL2, HIDDEN
  if n_elements(p) eq 0 then p=0
  if n_elements(skyf) eq 0 then skyf=0
  if n_elements(cf) eq 0 then cf=0
  if n_elements(pass) eq 0 then pass=1
  if n_elements(ath) eq 0 then ath=0.9

  if ath ge 1.0 then ath=1.0
  if ath lt 0.0 then ath=0.0

  if n_elements(reggood) ne 0 then reg=reggood

  sz = size(cube)

  if n_elements(maxalign) eq 0 then maxalign=sz[1]
  if maxalign gt sz[1] then maxalign=sz[1]
  if maxalign lt 2 then maxalign=2

  print, 'maxalign = ' + strtrim(maxalign,2)

  if n_elements(res) eq 0 then res = 10.0

  if res le 1.0 then res = 1.0

  if n_elements(centrepos) ne sz[2]*sz[3]/(res*res) then begin
    ; First, create an integrated sky spectrum
    ; On ne prend que la moitie du cube pour eviter
    ; d'etaler toute la raie lorsque le shift est grand
    ; sur le champ (comme pour ngc3034)
    ; Pour les galaxies ou le shift est petit, ca ne changera rien...
    if n_elements(reg) eq 0 then begin
      reg = {sky_zone}
      reg.x1 = sz[2]/4.0
      reg.x2 = 3.0*sz[2]/4.0
      reg.y1 = sz[3]/4.0
      reg.y2 = 3.0*sz[3]/4.0
    endif
    cubetemp = replicate(!values.f_nan, sz[1], sz[2]*sz[3])
    cubetemp[*, validCalib] = (reform(cube, sz[1], sz[2]*sz[3]))[*, validCalib]
    cubetemp = reform(cubetemp, sz[1], sz[2], sz[3])

    if n_elements(skyzone) ne 0 then begin
      cielitemp = medianRegion(cubetemp, skyzone, binSize=res)
    endif else begin
      cielitemp = medianRegion(cubetemp, reg, binSize=res)
    endelse
 
    cubetemp = 0

    maxcieli = max(cielitemp)
    if pass eq 0 then begin
      maxcieli = maxcieli*2.0
      mincieli = maxcieli/4.0
    endif else begin
      maxcieli = maxcieli*1.2
      mincieli = maxcieli/(1.2*1.2)
    endelse

    print, 'Maxcieli: ', maxcieli

    ; On normalise et on enleve le continum
    cielitemp = cielitemp - min(cielitemp)
    cielitemp = cielitemp / max(cielitemp)

    cielitemp = cielitemp*cielitemp
    cielitemp = cielitemp>(cielitemp[(sort(cielitemp))[sz[1]*0.8]])
    goodvalues = where(cielitemp gt min(cielitemp), complement=badvalues) 

    cielitemp = cielitemp - min(cielitemp)
    cielitemp = cielitemp / max(cielitemp)

    if p eq 1 then begin
      window, 1
      plot, cielitemp, color=128
    endif

    cieli = cielitemp

    lag = findgen(maxalign*10)/10.0-(maxalign/2) ;+1
    centrepos = fltarr(sz[2]/res, sz[3]/res)
    skyflat = fltarr(sz[2]/res, sz[3]/res)
    maxcc = fltarr(sz[2]/res, sz[3]/res)

    region = {sky_zone}

    for x=0, sz[2]/res-1 do begin
      for y=0, sz[3]/res-1 do begin
        region.x1 = x*res
        region.x2 = x*res+res

        region.y1 = y*res
        region.y2 = y*res+res

        raietemp = medianRegion(cube, region, binSize=res)
        raietemp2 = raietemp

        if max(raietemp) ne 0 then begin
          bar = baryc(raietemp)

          maxtemp = max(raietemp)

          if cf eq 1 then begin
            skyflat[x,y] = bar[3] ; On ne prend que le niveau du continum
          endif else begin
            skyflat[x,y] = maxtemp-bar[3] ; On soustrait le continum
          endelse

          raietemp = raietemp - min(raietemp)
          raietemp = raietemp / max(raietemp)
          raietemp = raietemp*raietemp
          raietemp = raietemp>(raietemp[(sort(raietemp))[sz[1]*0.8]])
;
;      ***** CHANGEMENT TEMPORAIRE!!!
;          raietemp[badvalues] = min(raietemp[goodvalues])
;      ***** Fin du changement temporaire

          raietemp = raietemp - min(raietemp)
          raietemp = raietemp / max(raietemp)

          cc = c_correlate(cieli, raietemp, lag)
          max = max(cc, idx)
          minlag = (idx-100)>0
          maxlag = (idx+100)<(maxalign*10-1)
;;          idx = (idx < ((maxalign-11)>0)) > (10<(maxalign-1))
          fit = poly_fit(lag[minlag:maxlag], cc[minlag:maxlag], 2)
          centrepos[x,y] = -0.5*fit[1]/fit[2]
;          print, centrepos[x,y]
;          centrepos[x,y] = lag[idx]

          if (maxtemp gt maxcieli) then max = 0
          if (maxtemp lt mincieli) then max = 0

          maxcc[x,y] = max

          if max ge ath then begin
            
            if p eq 1 then oplot,  raietemp2/max(raietemp2) ;(interpolate([raietemp, raietemp, raietemp], findgen(3*sz[3]/res)+centrepos[x,y]))[sz[3]/res:2*sz[3]/res-1]
          endif

        endif else begin
          centrepos[x,y] = !values.f_nan
          skyflat[x,y] = !values.f_nan
        endelse
      endfor
    endfor

    if n_elements(reggood) ne 0 then begin
      centrepos2 = fltarr(sz[2]/res, sz[3]/res)
      skyflat2 = fltarr(sz[2]/res, sz[3]/res)
      maxcc2 = fltarr(sz[2]/res, sz[3]/res)

      centrepos2[reggood[0].x1/res:reggood[0].x2/res-1, reggood[0].y1/res:reggood[0].y2/res-1] = centrepos[reggood[0].x1/res:reggood[0].x2/res-1, reggood[0].y1/res:reggood[0].y2/res-1]
      skyflat2[reggood[0].x1/res:reggood[0].x2/res-1, reggood[0].y1/res:reggood[0].y2/res-1] = skyflat[reggood[0].x1/res:reggood[0].x2/res-1, reggood[0].y1/res:reggood[0].y2/res-1]
      maxcc2[reggood[0].x1/res:reggood[0].x2/res-1, reggood[0].y1/res:reggood[0].y2/res-1] = maxcc[reggood[0].x1/res:reggood[0].x2/res-1, reggood[0].y1/res:reggood[0].y2/res-1]

      centrepos = centrepos2
      skyflat = skyflat2
      maxcc = maxcc2
    endif

    centrepos2 = fltarr(sz[2], sz[3])
    skyflat2 = fltarr(sz[2], sz[3])
    maxcc2 = fltarr(sz[2], sz[3])

    centrepos = congrid(centrepos, sz[2], sz[3])
    skyflat = congrid(skyflat, sz[2], sz[3])
    maxcc = congrid(maxcc, sz[2], sz[3])

    centrepos2[validCalib] = centrepos[validCalib]
    skyflat2[validCalib] = skyflat[validCalib]
    maxcc2[validCalib] = maxcc[validCalib]

    centrepos = centrepos2
    skyflat = skyflat2
    maxcc = maxcc2

;    centrepos = centrepos - median(centrepos)
  endif

  ; On fit seulement la ou le c_correlate est > 0.9
;  maxcc = congrid(maxcc, sz[2], sz[3])
  print, ath
  goodcc = where(maxcc ge ath)

  if p eq 1 then begin
    window, 0, xsize=sz[2], ysize=sz[3]
    todisplay = fltarr(sz[2], sz[3])
    todisplay += min(centrepos[goodcc])
    todisplay[goodcc] = centrepos[goodcc]
    todisplay = todisplay < 1.0
    todisplay = todisplay > (-1.0)
    todisplay += 1.0
    todisplay *= 255.0/2.0
    tv, todisplay
  endif

  print, 'Goodcc: ' + strtrim(n_elements(goodcc),2) + '/' + strtrim(n_elements(maxcc),2)

;  centrepos = congrid(centrepos, sz[2], sz[3])

  if goodcc[0] ne -1 then begin
    irr = fltarr(3, n_elements(goodcc))
    irr[0,*] = goodcc mod sz[2]
    irr[1,*] = floor(goodcc/sz[2])
    irr[2,*] = centrepos[goodcc]
    offsetirr = sfit(irr, 1, /irregular, kx=kx)

    offset = surfacefromkx(kx, sz[2], sz[3])

  endif else begin
    offset = sfit(centrepos, 1)
  endelse

  offset = offset-median(offset)

  if skyf eq 1 then begin
    print, 'Applying sky flat...'

;    skyflat = congrid(skyflat, sz[2], sz[3])
    if goodcc[0] ne -1 then begin
      irr = fltarr(3, n_elements(goodcc))
      irr[0,*] = goodcc mod sz[2]
      irr[1,*] = floor(goodcc/sz[2])
      irr[2,*] = skyflat[goodcc]
      skyflatirr = sfit(irr, 2, /irregular, max_degree=2, kx=kx)

      skyflat = surfacefromkx(kx, sz[2], sz[3])

      if n_elements(reggood) ne 0 then begin
        skyflat = skyflat / median(skyflat[reggood[0].x1:reggood[0].x2, reggood[0].y1:reggood[0].y2])
      endif else begin
        skyflat = skyflat / median(skyflat)
      endelse

    endif else begin
      skyflat = sfit(skyflat, 2, max_degree=2)
      if n_elements(reggood) ne 0 then begin
        skyflat = skyflat / median(skyflat[reggood[0].x1:reggood[0].x2, reggood[0].y1:reggood[0].y2])
      endif else begin
        skyflat = skyflat / median(skyflat[validCalib])
      endelse

    endelse

    for i=0, sz[1]-1 do begin
      cube[i,*,*] = cube[i,*,*] / skyflat
    endfor
  endif

  if p eq 1 then begin
    window, 2, xsize=sz[2], ysize=sz[3]
    todisplay = offset
    todisplay = todisplay < 1.0
    todisplay = todisplay > (-1.0)
    todisplay += 1.0
    todisplay *= 255.0/2.0
    tv, todisplay

    window, 3, xsize=sz[2], ysize=sz[3]
    todisplay = skyflat
    todisplay = todisplay < 2.0
    todisplay = todisplay > 0.5
    idx = where(todisplay lt 1.0)
    if idx[0] ne -1 then todisplay[idx] = 1.0-((1.0/todisplay[idx])-1.0)
    todisplay *= 255.0/2.0
    tv, todisplay

  endif

  cubeFinal = fltarr(sz[1], sz[2], sz[3], /nozero)

  ; Apply the shift
  ind = findgen(sz[1]*2)
  raie = fltarr(sz[1]*2)
  for x=0, sz[2]-1 do begin
    for y=0, sz[3]-1 do begin
      raietemp = cube[*,x,y]

      raie = [raietemp, raietemp, raietemp]
;      raie = raie[sz[1]/2:sz[1]*4-sz[1]/2-1]

;      raie[0:sz[1]/2-1] = raietemp[sz[1]/2:sz[1]-1]
;      raie[sz[1]/2:sz[1]*1.5-1] = raietemp
;      raie[sz[1]*1.5:sz[1]*2-1] = raietemp[0:sz[1]/2-1]

      raie = interpolate(raie, ind+offset[x,y])

      cubeFinal[*,x,y] = raie[sz[1]:sz[1]*2-1] ;raie[sz[1]/2:sz[1]*1.5-1]
    endfor
  endfor

  ohmap = fltarr(sz[2], sz[3])
  ohmap[where(maxcc ge 0.9)] = 1.0

  return, cubeFinal
end


function alignLines, cube, offset, skyflat, validCalib, resolution=res, plot=p, npass=n, flatonly=fo, region=reg, continumflat=cf, ohmap=ohmap, noflat=nf, skyzone=skyzone, alignthreshold=ath, maxlag=maxlag
COMPILE_OPT IDL2

  if n_elements(p) eq 0 then p=0
  if n_elements(n) eq 0 then n=20
  if n_elements(fo) eq 0 then fo=0
  if n_elements(cf) eq 0 then cf=0
  if n_elements(nf) eq 0 then nf=0

  if fo eq 1 then n=1

  n = (n - 1) > 0

  iteration = 0

  cube_temp = cube
  sz = size(cube)

  while iteration le n do begin
    if nf eq 0 then begin
      if iteration eq 0 then skyf = 1 else skyf = 1

      cube = align(cube, offset, validCalib, sky_flat=skyf, map_sky_flat=skyflat, resolution=res, plot=p, region=reg, continumflat=cf, ohmap=ohmap, skyzone=skyzone, pass=iteration, alignthreshold=ath, maxlag=maxlag)
    endif else begin
      cube = align(cube, offset, validCalib, resolution=res, plot=p, region=reg, ohmap=ohmap, skyzone=skyzone, pass=0, alignthreshold=ath, maxlag=maxlag)
    endelse

    if n_elements(offset_final) eq 0 then begin
      offset_final=offset
    endif else begin
      offset_final = offset_final + offset
    endelse

    if nf eq 0 then begin
      if n_elements(skyflat_final) eq 0 then begin
        skyflat_final = skyflat
      endif else begin
        if skyf ne 0 then skyflat_final = skyflat_final * skyflat
      endelse
    endif

    offset_temp = fltarr(sz[2], sz[3])
    offset_temp[validCalib] = offset[validCalib]

    if n_elements(reg) ne 0 then begin
      mm = minmax(offset_temp[where(skyZoneToMask(reg, sz[2], sz[3]) ne 0)])
      mmean = mean(abs(offset_temp[where(skyZoneToMask(reg, sz[2], sz[3]) ne 0)]))
    endif else begin
      mm = minmax(offset_temp)
      mmean = mean(abs(offset_temp))
    endelse

    print, '  offset: ' + strtrim(mm[0],2) + ':' + strtrim(mm[1],2)
    print, '    mean: ' + strtrim(mmean,2)

    if abs(mm[0]-mm[1]) le 0.1 then break
    if mmean le 0.01 then break

    if fo eq 1 then break

    iteration = iteration + 1

  endwhile

  print, minmax(offset_final)

  offset = offset_final

;  return, cube

  sz = size(cube_temp)

  if nf ne 0 then begin
    skyflat_final = replicate(float(1.0), sz[2], sz[3])
  endif

  for i=0, sz[1]-1 do cube_temp[i,*,*] = cube_temp[i,*,*] / skyflat_final

  if fo eq 1 then return, cube_temp

;  raie = fltarr(sz[1]*3)
  ind = findgen(sz[1]*3)

  for x=0, sz[2]-1 do begin
    for y=0, sz[3]-1 do begin
      raietemp = cube_temp[*,x,y]

      raie = [raietemp, raietemp, raietemp]
;      raie[0:floor(sz[1]/2.0-1)] = raietemp[ceil(sz[1]/2.0):sz[1]-1]
;      raie[floor(sz[1]/2.0):sz[1]*1.5-1] = raietemp
;      raie[sz[1]*1.5:sz[1]*2-1] = raietemp[0:sz[1]/2-1]

      raie = interpolate(raie, ind+offset_final[x,y])

;      cube_temp[*,x,y] = raie[sz[1]/2:sz[1]*1.5-1]
      cube_temp[*,x,y] = raie[sz[1]:sz[1]*2-1]
    
    endfor
  endfor

  skyflat = skyflat_final

  return, cube_temp

end
