function createBru, cal
COMPILE_OPT IDL2

  sz = size(cal)

  bru = fltarr(sz[2], sz[3])
  for i=0, sz[2]-1 do begin
;      print, i
    for j=0, sz[3]-1 do begin
;      toto = writead1('raie.ad1', cal[*,i,j])
      pos = baryc(cal[*,i,j])
      
      bru[i,j] = pos[0]
;      if pos[0] gt sz[1]+1 then begin
;        print, pos
;        plot, cal[*,i,j]
;        cursor, x, y, /device, /up
;      endif

    endfor
  endfor

  return, bru
end

function createSum, cal
COMPILE_OPT IDL2

  sz = size(cal)

  sum = fltarr(sz[2], sz[3])
  for i=0, sz[2]-1 do begin
    for j=0, sz[3]-1 do begin
      sum[i,j] = total(cal[*,i,j])
    endfor
  endfor

  return, sum
end

function createPrb, cal, bru, sum, cen, trailer, calibwl, rvcal, validCalib, finesse, usebrute=usebrute
COMPILE_OPT IDL2

  sz = size(cal)

  prb = fltarr(sz[2], sz[3])

  dist_circle, cir, sz[2], cen[0], cen[1]
  
  deriv = abs(deriv(bru))

  inter = cir[where(deriv gt (max(deriv)/2))]
  
  interfrangeRegion = 0
  interfrange = 0
  sz1 = float(sz[1])
  firstInterfrangePosition = 0

;  prev = bru[floor(cen[0]), floor(cen[1])]
  max = sqrt(cen[0]^2+cen[1]^2)
  max = max > sqrt((cen[0]-sz[2])^2+cen[1]^2)
  max = max > sqrt((cen[0]-sz[2])^2+(cen[1]-sz[3])^2)
  max = max > sqrt(cen[0]^2+(cen[1]-sz[3])^2)

  i=float(0)

  while i le max do begin
    idx = where((cir ge i) and (cir lt (i+1.0)))
    if (n_elements(idx) ne 1) and (idx[0] ne -1) then begin
      if interfrangeRegion ne 1 then begin
        interfrangeRegion = (median(bru[idx]) gt sz1*0.75)?1:0
      endif

      if (interfrange eq 0) or (i lt 100) then firstInterfrangePosition = i

      if interfrangeRegion eq 1 then begin
        low = where(bru[idx] le 0.5*sz[1], complement=hi)

        if (n_elements(low) ne 1) and low[0] ne -1 then begin
          prb[idx[low]] = bru[idx[low]]+((interfrange+1.0)*sz1)
        endif
        if (n_elements(hi) ne 1) and hi[0] ne -1 then begin
          prb[idx[hi]] = bru[idx[hi]]+(interfrange*sz1)
        endif

        interfrangeRegion = ((median(bru[idx]) le sz[1]*0.25) or (median(bru[idx]) gt sz1*0.75))?1:0

        if interfrangeRegion ne 1 then begin
          interfrange = interfrange + 1
          print, '    ' + strtrim(interfrange,2) + ' at ' + strtrim(i,2)
        endif

      endif else begin
        prb[idx] = bru[idx]+(float(interfrange)*float(sz[1]))
      endelse

    endif
    i = i+0.5
  endwhile

  firstInterfrangePosition = firstInterfrangePosition < 100

  print, firstInterfrangePosition
  med = median(sum[where(cir lt firstInterfrangePosition)])
  validCalib = where(sum ge med/2, complement=nogood)

  if firstInterfrangePosition ne 0 then begin
    fit2 = fltarr(sz[2], sz[3])
    fit4 = fltarr(sz[2], sz[3])
    fit = fltarr(sz[2], sz[3])
    med = median(sum[where(cir lt firstInterfrangePosition)])
    validCalib = where(sum ge med/2, complement=nogood)

    ; Pour faire le fit, on doit y aller de maniere 'irreguliere'...
    irr = fltarr(3, n_elements(validCalib))
    irr[0,*] = validCalib mod sz[2]     ; x
    irr[1,*] = floor(validCalib/sz[2])  ; y
    irr[2,*] = prb[validCalib]          ; z
    
    result = sfit(irr, 2, /irregular, max_degree=2)
    if (n_elements(nogood) ne 1) and (nogood[0] ne -1) then fit[nogood] = prb[nogood]
    fit[validCalib] = result

    result = sfit(irr, 2, /irregular)
    if (n_elements(nogood) ne 1) and (nogood[0] ne -1) then fit2[nogood] = prb[nogood]
    fit2[validCalib] = result

    result = sfit(irr, 4, /irregular, max_degree=4)
    if (n_elements(nogood) ne 1) and (nogood[0] ne -1) then fit4[nogood] = prb[nogood]
    fit4[validCalib] = result
  endif else begin
    fit = sfit(prb, 2, max_degree=2)
    fit2 = sfit(prb, 2)
    fit4 = sfit(prb, 4, max_degree=4)
  endelse

  smo = smooth(prb, 2, /edge_truncate)

  decal = ((trailer.xl1-calibwl)/trailer.xi1 * float(sz[1])) mod float(sz[1])
  if trailer.xl1 gt calibwl then decal = -abs(decal) else decal = abs(decal)
  print, '    Decal is ' + strtrim(decal,2)
  fit = fit - decal
  fit2 = fit2 - decal
  fit4 = fit4 - decal
  smo = smo - decal
  prb = prb - decal

  if prb[(cen[0]>0)<(sz[2]-1), (cen[1]>0)<(sz[3]-1)] lt 0 then begin
    offset = ceil(-min(fit)/sz[1])*sz[1]
    print, 'Lt ', offset
    fit = fit + offset
    fit2 = fit2 + offset
    fit4 = fit4 + offset
    smo = smo + offset
    prb = prb + offset
  endif

  if prb[(cen[0]>0)<(sz[2]-1), (cen[1]>0)<(sz[3]-1)] then begin
    offset = ceil(min(fit)/sz[1])*sz[1]
    print, 'Gt ', offset
    fit = fit - offset
    fit2 = fit2 - offset
    fit4 = fit4 - offset
    smo = smo - offset
    prb = prb - offset
  endif

;  finfit = computecalibrationfinesse(cal, fit, cen, plot=0, validCalib=validCalib)
  finfitcen = computecalibrationfinesse(cal, fit, cen, plot=0)
;  print, '2nd fit finesse: ' + strtrim(finfit,2) + ', ' + strtrim(finfitcen,2)
  print, '2nd fit finesse: ' + strtrim(finfitcen,2)

;  finfit2 = computecalibrationfinesse(cal, fit2, cen, plot=0, validCalib=validCalib)
  finfit2cen = computecalibrationfinesse(cal, fit2, cen, plot=0)
;  print, '2nd nomax fit finesse: ' + strtrim(finfit2,2) + ', ' + strtrim(finfit2cen,2)
  print, '2nd nomax fit finesse: ' + strtrim(finfit2cen,2)

;  finfit4 = computecalibrationfinesse(cal, fit4, cen, plot=0, validCalib=validCalib)
  finfit4cen = computecalibrationfinesse(cal, fit4, cen, plot=0)
;  print, '4th fit finesse: ' + strtrim(finfit4,2) + ', ' + strtrim(finfit4cen,2)
  print, '4th fit finesse: ' + strtrim(finfit4cen,2)

;  finsmo = computecalibrationfinesse(cal, smo, cen, plot=0, validCalib=validCalib)
  finsmocen = computecalibrationfinesse(cal, smo, cen, plot=0)
;  print, 'smoothed finesse: ' + strtrim(finsmo,2) + ', ' + strtrim(finsmocen,2)
  print, 'smoothed finesse: ' + strtrim(finsmocen,2)

;  finprb = computecalibrationfinesse(cal, prb, cen, plot=0, validCalib=validCalib)
  finprbcen = computecalibrationfinesse(cal, prb, cen, plot=0)
;  print, 'rough finesse: ' + strtrim(finprb,2) + ', ' + strtrim(finprbcen,2)
  print, 'rough finesse: ' + strtrim(finprbcen,2)

  finfit = finfitcen ;mean([finfit, finfitcen])
  finfit2 = finfit2cen ;mean([finfit2, finfit2cen])
  finfit4 = finfit4cen ;mean([finfit4, finfit4cen])
  finsmo = finsmocen ;mean([finsmo, finsmocen])
  finprb = finprbcen ;mean([finprb, finprbcen])

  max = max([finfit, finfit2, finfit4, finsmo, finprb], idx)

  if (idx eq 0) and (keyword_set(usebrute) eq 0) then begin
    print, 'According to finesse, fitted calibration (2nd) is better (mean of ' + strtrim(finfit,2) + ' against ' + strtrim(finsmo,2) + ' and ' + strtrim(finprb,2) + ')'
    finesse = finfit
  endif
  if (idx eq 1) and (keyword_set(usebrute) eq 0) then begin
    print, 'According to finesse, fitted calibration (2nd, nomax) is better (mean of ' + strtrim(finfit,2) + ' against ' + strtrim(finsmo,2) + ' and ' + strtrim(finprb,2) + ')'
    fit = fit2
    finesse = finfit2
  endif
  if (idx eq 2) and (keyword_set(usebrute) eq 0) then begin
    print, 'According to finesse, fitted calibration (4th) is better (mean of ' + strtrim(finfit,2) + ' against ' + strtrim(finsmo,2) + ' and ' + strtrim(finprb,2) + ')'
    fit = fit4
    finesse = finfit4
  endif
  if (idx eq 3) and (keyword_set(usebrute) eq 0)  then begin
    print, 'According to finesse, smoothed calibration is better (mean of ' + strtrim(finsmo,2) + ' against ' + strtrim(finfit,2) + ' and ' + strtrim(finprb,2) + ')'
    fit = smo
    finesse = finsmo
  endif
  if (idx eq 4)  and (keyword_set(usebrute) eq 1) then begin
    print, 'According to finesse, rough calibration is better (mean of ' + strtrim(finprb,2) + ' against ' + strtrim(finfit,2) + ' and ' + strtrim(finsmo,2) + ')'
    fit = prb
    finesse = finprb
  endif


;  med = abs(median(prb-fit))

;  print, '    Median of difference: ' + strtrim(med, 2)
;  if med ge 0.1 then begin
;    print, '      Difference is too big. We will smooth instead of fitting...'
;    fit = smooth(prb, 2, /edge_truncate)
;  endif

  rvcal = fit - prb

  ; Maintenant, on decale tout pour
  ; ramener la calibration au premier canal
  ; ON A BESOIN DE LA LONGUEUR D'ONDE DE CALIBRATION!
;  print, calibwl
;  help, /structure, trailer
;  print, sz[1]

;  decal = ((trailer.xl1-calibwl)/trailer.xi1 * float(sz[1])) mod float(sz[1])
;  if trailer.xl1 gt calibwl then decal = -abs(decal) else decal = abs(decal)
;  print, '    Decal is ' + strtrim(decal,2)
;  fit = fit - decal

;  print, 'Center is at ' + strtrim(fit[cen[0], cen[1]], 2)

;  if fit[cen[0], cen[1]] lt 0 then begin
;    offset = ceil(-min(fit)/sz[1])*sz[1]
;    print, 'Lt ', offset
;    fit = fit + offset
;  endif

;  if fit[cen[0], cen[1]] gt sz[1] then begin
;    offset = ceil(min(fit)/sz[1])*sz[1]
;    print, 'Gt ', offset
;    fit = fit - offset
;  endif

;  rvcal = createBru(createlambda(cal, fit))
;  rvcal = rvcal - median(rvcal)

  return, fit

end

pro calibrate, cal, trailer, calibwl, bru, prb, sum, rvcal, finesse, validCalib, center=cen, usebrute=usebrute
COMPILE_OPT IDL2

  sz = size(cal)

  print, '  Creating brute phase'
  bru = createBru(cal)
  print, '  Creating flat calibration'
  sum = createSum(cal)
  
  if n_elements(cen) ne 2 then begin
    print, '  Looking for center...'
    cen = findCalibrationCenter(bru)
  endif else begin
    print, '  Using center at (' + strtrim(cen[0],2) + ', ' + strtrim(cen[1],2) + ')'
  endelse

  print, '  Creating parabolic phase'
  prb = createPrb(cal, bru, sum, cen, trailer, calibwl, rvcal, validCalib, finesse, usebrute=usebrute)
  rvcal = rvcal*(trailer.xik/float(sz[1]))  ; Converting rvcal from channels to km/s
end
