function is_smaller_mtime, unit, units
COMPILE_OPT IDL2, HIDDEN
  small = 0
  for i=0, n_elements(units)-1 do if unit.mtime le units[i].mtime then small=1
  return, small
end

function file_info_gz, filename
  info = file_info(filename)
  if info.exists eq 0 then info = file_info(filename + '.gz')

  return, info
end


pro coaddlambdafiles, dirs, align=a, remove_sky=sky, spectral_smooth=sl, ohmap_remove_sky=ohsky, rotate=rot, expand=expand, noz=noz

  if n_elements(a) eq 0 then a=0
  if n_elements(sky) eq 0 then sky=1
  if n_elements(sl) eq 0 then sl=1
  if n_elements(correctGuiding) eq 0 then c=0
  if n_elements(ohsky) eq 0 then ohsky=1
  if n_elements(expand) eq 0 then expand=0

  if n_elements(rot) eq 0 then rot = bytarr(n_elements(dirs)-1)

  if n_elements(rot) ne n_elements(dirs)-1 then begin
    print, 'Warning! Not enough rotation parameters given!'
    rot = bytarr(n_elements(dirs)-1)
  endif

  align = a eq 1?'-aligned':''
  if ohsky eq 1 then begin
    oh    = sky eq 1?'-OHmap':''
  endif else begin
    oh    = sky eq 1?'-OH':''
  endelse
  sz    = sl ge 1?'-SZ'+strtrim(long(sl),2):''

  info_base = file_info_gz(my_filepath('lambda' + sz + align + oh + '-coadd.ad3', subdirectory=[dir[0]]))

  for i=1, n_elements(dirs)-1 do begin
    if i eq 1 then begin
      info = file_info_gz('lambda' + sz + align + oh + '.ad3', subdirectory=[dir[i]]))
    endif else begin
      info = [info, file_info_gz(my_filepath('lambda' + sz + align + oh + '.ad3', subdirectory=[dir[i]]))]
    endelse
  endfor

  if is_smaller_mtime(info_base, info) eq 0 then return

  print, 'Coadding files from ' 
  print, dirs

  for i=0, n_elements(dirs)-1 do begin
    if i eq 0 then begin
      lambda = readad3(my_filepath('lambda' + sz + align + oh + '.ad3', subdirectory=[dir[i]]), trailer)
;      if file_test(dirs[i] + '/roi.adz', /read) eq 1 then begin
;        roi = adztoskyzone(readadz(dirs[i] + '/roi.adz'))
;      endif
      if file_test(my_filepath('alignzone.adz', subdirectory=[dir[i]]), /read) eq 1 then begin
        alignzoneOrig = adztoskyzone(readadz(my_filepath('alignzone.adz', subdirectory=[dir[i]])))
      endif
    endif else begin
      lambda2 = readad3(my_filepath('lambda' + sz + align + oh + '.ad3', subdirectory=[dir[i]]))
;      if file_test(dirs[i] + '/roi.adz', /read) eq 1 then begin
;        roi2 = adztoskyzone(readadz(dirs[i] + '/roi.adz'))
;      endif
      alignzone = 0
      if file_test(my_filepath('alignzone.adz', subdirectory=[dir[i]]), /read) eq 1 then begin
        alignzone = adztoskyzone(readadz(my_filepath('alignzone.adz', subdirectory=[dir[i]])))
      endif
      lambda = coAddLambda(lambda, lambda2, rotate=rot[i-1], expand=expand, alignzone1=alignzoneorig, alignzone2=alignzone, noz=noz)
    endelse
  endfor

  toto = writead3(my_filepath('lambda' + sz + align + oh + '-coadd.ad3', subdirectory=[dir[i]]), lambda, trailer)

end
