pro findprofile, raie, center, height, continum, fit, left, right

  sz = size(raie)

  output = baryc(raie)
  left = output[7]
  right = output[8]
  continum = output[3]

  fit1 = makeGaussian([2*output[1], output[0], output[5]/(2*sqrt(2*alog(2))), output[3]], findgen(sz[1]*10)/10)
  fit2 = gaussfit(findgen(sz[1]*10)/10, congrid(raie, sz[1]*10), a, nterms=4, sigma=sigma)

  test = fltarr(sz[1])+1.0

  if left gt right then begin
    test[left:sz[1]-1] = 0
    test[0:right] = 0
  endif else begin
    test[left:right] = 0
  endelse

  real = raie * test
  fittest = fit1 * test
  test1 = total((real-fittest)^2)
  fittest = fit2 * test
  test2 = total((real-fittest)^2)

  if test1 lt test2 then begin
    fit = fit1
    print, 'Using barycenter'
    center = output[0]
    height = output[6]
  endif else begin
    fit = fit2
    print, 'Using gaussian'
    center = a[1]
    height = a[0]/2.0 + a[3]
  endelse


end


pro findlines, raie, index=idx, max=m

  if n_elements(m) eq 0 then m = 3
  if n_elements(idx) ne n_elements(raie) then idx = findgen(n_elements(raie))
  m = m-1

  sz = size(raie)

  loadct, 39

  window, 0
  plot, idx, raie, /ynozero, psym=10
  offset=0

  for i=0, m do begin
    findprofile, raie, center, height, continum, fit, left, right

    realcenter = min(idx)+center/float(n_elements(idx))*(max(idx)-min(idx)) 
    print, center, height, continum, realcenter

    oplot, min(idx)+findgen(sz[1]*10)/10.0*(max(idx)-min(idx))/float(sz[1]), fit-offset, color=64
    oplot, [realcenter], [height-offset], psym=1, color=64
    oplot, [realcenter, realcenter], minmax(raie), color=64, linestyle=1

    xyouts, realcenter, max(raie), strtrim(realcenter,2), alignment=0.5, color=64

    fit = congrid(fit, sz[1])
    oplot, fit, color=128, psym=10
    raie = raie - fit
    raie += min(fit)

;    offset = mean(raie[left:right]-continum)
    raie[left:right] = continum    

;    window, i+1
;    plot, raie, /ynozero, psym=10
;    tvset, 0
  endfor


end
