function findOH, cube, res, validCalib=validCalib, roi=roi, correlation=cf

  if n_elements(cf) eq 0 then cf = 0.9
  if cf ge 1.0 then cf=1.0
  if cf le 0.1 then cf=0.1

  sz=size(cube)

  if n_elements(validCalib) ne 0 then begin
    cubetemp = replicate(!values.f_nan, sz[1], sz[2]*sz[3])
    cubetemp[*,validCalib] = (reform(cube, sz[1], sz[2]*sz[3]))[*, validCalib]
    cubetemp = reform(cubetemp, sz[1], sz[2], sz[3])
  endif else begin
    cubetemp = cube
  endelse

  if n_elements(roi) ne 0 then begin
    bigSpectrum = medianRegion(cubetemp, roi, binsize=res)
  endif else begin
    bigSpectrum = medianRegion(cubetemp, binsize=res)
  endelse

  bigSpectrum -= min(bigSpectrum)
  maxBig = max(bigSpectrum)

  smallSky = fltarr(sz[1], sz[2]/res, sz[3]/res)
  ccMap = fltarr(sz[2]/res, sz[3]/res)
  maxmap = fltarr(sz[2]/res, sz[3]/res)
  ohMap = fltarr(sz[2]/res, sz[3]/res)

  lag = (findgen(100)/50.0)-1.0

  for x=0, sz[2]/res-1 do begin
    for y=0, sz[3]/res-1 do begin
      region = {sky_zone}
      region.x1 = x*res
      region.x2 = x*res+res
      region.y1 = y*res
      region.y2 = y*res+res
   
;      print, region

      spectrum = medianRegion(cube, region, binsize=res)
      spectrum -= min(spectrum)

      cc = c_correlate(bigSpectrum, spectrum, lag)
      cc = max(cc)

;      max = max(cc, idx)
;      idx = (idx < (n_elements(lag)-11)) > 10
;      fit = poly_fit(lag[idx-10:idx+10], cc[idx-10:idx+10], 2)

      max = max(spectrum)

      ccMap[x,y] = cc
      maxMap[x,y] = max(spectrum)
  
      if (cc ge cf) and (max gt 0.8*maxBig) and (max lt 1.5*maxBig) then ohMap[x,y]=1
      
    endfor
  endfor

  ohMapFinal = fltarr(sz[2], sz[3])
  maxx = floor(sz[2]/res)*res
  maxy = floor(sz[3]/res)*res
  ohMapFinal[0:maxx-1, 0:maxy-1] = congrid(ohMap, maxx, maxy)

  return, ohMapFinal

end
