
pro finish_rv, ifname, ofname, sn
COMPILE_OPT IDL2

  if n_params() eq 0 then begin
    print, 'Syntax: finish_rv, ifname, ofname'
    print, 'ifname - Input ad3 filename'
    print, 'ofname - Output ad3 filename'
    print, '    sn - Wanted SNR' 
    goto, fin
  endif

  cube = readad3(ifname, trailer)

  sz = size(cube)

  xsize=sz[1]
  ysize=sz[2]

  window, 0, xsize=xsize, ysize=ysize
  tvscl, rescale(total(cube, 3), 0.01, 0.99)

  print, 'Size: ', strtrim(xsize*ysize, 2), ' pixels (', strtrim(xsize, 2), 'x', strtrim(ysize, 2), ')'

  cubeSmooth = voronoi_3d_fast(cube, sn, x, y, signal, noise, signal2d, noise2d, binnum, xnode, ynode, xbar, ybar, sn, sn2d, npixels)

  writefits, 'signal.fits', signal2d
  writefits, 'noise.fits', noise2d

  out = transpose(cubeSmooth, [2,0,1])

  toto = writead3(ofname, out, trailer, data_xyz=0)


end



