function integrateAda, directory, nphotons, ignorecycle=ignorecycle
COMPILE_OPT IDL2
  pushd, directory

  sz = readadt(adtch, adtcy, adteff)

  xsize = sz[1]
  ysize = sz[2]
  zsize = sz[0]

  neb = fltarr(zsize, xsize, ysize)

  ada = file_search('*.ada')
  if n_elements(ada) eq 1 then begin
    ada = file_search('*.ADA')
  endif

  cycles = strmid(ada, 4, 2)
  channels = strmid(ada, 6, 2)

  if channels[0] eq 0 then begin
    ada = ada[1:n_elements(ada)-1]
    channels = channels[1:n_elements(channels)-1]
    cycles = cycles[1:n_elements(cycles)-1]
  endif

  ; On retire les cycles incomplets...
  nchannels = max(channels)
  ncycles = max(cycles)
  bad = 0
  badcycles = 0
  for i=1, ncycles do begin
    elem = where(cycles eq i)
    if n_elements(elem) lt nchannels then begin
      bad = [bad, elem]
      badcycles = [badcycles, i]
      print, 'Removing cycle ' + strtrim(i,2)
    endif
  endfor

  if n_elements(bad) ne 1 then begin
    bad = bad[1:n_elements(bad)-1]
    badcycles = badcycles[1:n_elements(badcycles)-1]
    remove, bad, ada
    remove, bad, channels
    remove, bad, cycles
    for i=0, n_elements(badcycles)-1 do begin
      idx = where(adtcy eq badcycles[i])
      if idx[0] ne -1 then begin
        remove, idx, adtch
        remove, idx, adtcy
        remove, idx, adteff
      endif
    endfor

  endif

  if n_elements(ignorecycle) ne 0 then begin
    for i=0, n_elements(ignorecycle)-1 do begin
      idx2 = where(cycles eq ignorecycle[i])
      idx = where(cycles ne ignorecycle[i])
      if (idx[0] ne -1) and (idx2[0] ne -1) then begin
        print, 'Ignoring cycle ' + strtrim(ignorecycle[i],2)
        ada = ada[idx]
        cycles = cycles[idx]
        channels = channels[idx]

        idx = where(adtcy eq ignorecycle[i])
        if idx[0] ne -1 then begin
          remove, idx, adtch
          remove, idx, adtcy
          remove, idx, adteff
        endif
      endif
    endfor
  endif

  nphotons=0

  for i=0, zsize-1 do begin
    test = where(channels eq (i+1))

    eff = where(adtch eq (i+1))

;    neb = readAda(ada[test], xsize, ysize, adteff[eff], nphotons)

    if test[0] ne -1 then begin
      neb[i, *, *] = neb[i, *, *] + readada(ada[test], xsize, ysize, adteff[eff], np)
      nphotons = nphotons+np
    endif
  endfor

  popd

  return, neb

end
