function reorderAdaChronogically, ada
  cycles = strmid(ada, 4, 2)
  channels = strmid(ada, 6, 2)

  for i=1, max(cycles) do begin
    if (i mod 2) eq 1 then continue
    
    idx = where(cycles eq i)
    if idx[0] eq -1 then continue
    
    ada[idx] = ada[reverse(idx)]
  endfor

  return, ada
end

function integrateAdaAndRemoveSky, directory, prb, cen, flux, p, ignorecycle=ignorecycle
COMPILE_OPT IDL2

  if n_elements(p) eq 0 then p = 1

  if n_elements(nobreak) eq 0 then nobreak=0

  pushd, directory

  sz = readadt(adtch, adtcy, adteff)

  xsize = sz[1]
  ysize = sz[2]
  zsize = sz[0]

;  if n_elements(correctNum) eq 0 then correctNum = 5  ; Correct position every 5 ada

  ada = findfile('*.[aA][dD][aA]')

  ada = reorderAdaChronogically(ada)

  cycles = strmid(ada, 4, 2)
  channels = strmid(ada, 6, 2)

  if channels[0] eq 0 then begin
    ada = ada[1:n_elements(ada)-1]
    channels = channels[1:n_elements(channels)-1]
    cycles = cycles[1:n_elements(cycles)-1]
  endif

  ; On retire les cycles incomplets...
  nchannels = max(channels)
  ncycles = max(cycles)
  bad = 0
  for i=1, ncycles do begin
    elem = where(cycles eq i)
    if n_elements(elem) lt nchannels then begin
      bad = [bad, elem]
      print, 'Removing cycle ' + strtrim(i,2)
    endif
  endfor

  if n_elements(bad) ne 1 then begin
    bad = bad[1:n_elements(bad)-1]
    remove, bad, ada
    remove, bad, channels
    remove, bad, cycles
  endif

  if n_elements(ignorecycle) ne 0 then begin
    for i=0, n_elements(ignorecycle)-1 do begin
      idx2 = where(cycles eq ignorecycle[i])
      idx = where(cycles ne ignorecycle[i])
      if (idx[0] ne -1) and (idx2[0] ne -1) then begin
        print, 'Ignoring cycle ' + strtrim(ignorecycle[i],2)
        ada = ada[idx]
        cycles = cycles[idx]
        channels = channels[idx]
      endif
    endfor
  endif

  nphotons = fltarr(n_elements(ada))

  if p eq 1 then begin
    window, 0, xsize=xsize, ysize=ysize
    loadct, 0, /silent
  endif

  neb = fltarr(zsize, xsize, ysize)

  dist_circle, cir, sz[2], cen[0], cen[1]
  hist = histogram(cir, binsize=4, reverse_indices=r)

  max = sqrt(cen[0]^2+cen[1]^2)
  max = max > sqrt((cen[0]-xsize)^2+cen[1]^2)
  max = max > sqrt((cen[0]-xsize)^2+(cen[1]-ysize)^2)
  max = max > sqrt(cen[0]^2+(cen[1]-ysize)^2)
  max -= (max mod 4)
  max /= 4

  arrayx = (abs(findgen(xsize)-cen[0]) # replicate(1,ysize))/4
  arrayy = (replicate(1,xsize) # abs(findgen(ysize)-cen[1]))/4
  array = sqrt(arrayx^2+arrayy^2)
  array2 = array^2
  array3 = array^3
  array4 = array^4

  for i=0, zsize-1 do begin

    print, 'Processing channel ' + strtrim(i,2)

    test = where(channels eq i+1)
    if test[0] ne -1 then begin
      temp = fltarr(n_elements(test), xsize, ysize)
      meds = fltarr(n_elements(test))
      means = fltarr(n_elements(test))

      for j=0, n_elements(test)-1 do begin
        temp[j,*,*] = readada(ada[test[j]], xsize, ysize, silent=1)
;        imtemp = rebin(reform(temp[j,*,*]), xsize/4, ysize/4)
;        meds[j] = median(imtemp)
;        meds[j] = median(temp[j,*,*])
      endfor

      radial_flux = fltarr(n_elements(test), max)

      filename = 'channel-'+strtrim(i,2)+'-radialflux.fits'

      if file_test(filename, /read) then begin
        radial_flux = readfits(filename, /silent)
      endif else begin

        for j=0, max-1 do begin
          print, j
          idx = r[r[j]:r[j+1]-1]
          for k=0, n_elements(test)-1 do begin
            radial_flux[k,j] = mean((reform(temp[k,*,*]))[idx])
          endfor
        endfor
 
        writefits, filename, radial_flux

      endelse

      if keyword_set(p) then plot, radial_flux[0,*]

      for k=1, n_elements(test)-1 do begin
        error = reform(radial_flux[k,*] - radial_flux[0,*])
        fit = poly_fit(findgen(max), error, 4, yfit=yfit)

        if keyword_set(p) then oplot, radial_flux[k,*] - yfit

        map = fit[0] + fit[1]*array + fit[2]*array2 + fit[3]*array3 + fit[4]*array4
        temp[k,*,*] -= map
;        if k eq 13 then error
      endfor

;      fit = poly_fit(findgen(max), reform(error

;      for j=0, n_elements(test)-1 do begin
;        meds[j] = median(radial_flux[j,*])
;      endfor

;      meds -= min(meds)

;      for j=0, n_elements(test)-1 do begin
;        temp[j,*,*] -= meds[j]
;      endfor

      temp = total(temp,1)
    endif else continue

    neb[i, *,*] = temp

  endfor

;  radial_flux = fltarr(zsize, max)
;
;  for j=0, max-1 do begin
;    idx = r[r[j]:r[j+1]-1]
;    for i=0, zsize-1 do begin
;      radial_flux[i,j] = mean((reform(neb[i,*,*]))[idx])
;    endfor  
;  endfor

  popd

  return, neb ;createlambda(cube_ciel, prb)

end
