function makeGaussian, a, x

; a[0]: height
; a[1]: position du centre
; a[2]: fwhm/(2.0*sqrt(2.0*alog(2.0)))
; a[3]: continuum

  y = fltarr(n_elements(x))

  if a[2] ne 0 then begin
    z = (x-a[1])/a[2]

    switch n_elements(a) of
      6: y = y + a[5]*x*x
      5: y = y + a[4]*x
      4: y = y + a[3] ; replicate(a[3], n_elements(x))
      3: y = y + a[0]*exp(-z^2/2)
    endswitch
  endif

  return, y

end
