pro printAdtStatistics, dir
  toto = mean([0,0])
  pushd, dir
  zxy = readAdt(channels, cycles, efficiency, qgval, exposure, swvl, qgcte, identification, interferometer, filter, date, time)

  print, identification
  print, '  ' + date + ' ' + time
  print, '  ' + strtrim(interferometer,2) + ' interferometer order'
  print, '  ' + strtrim(swvl,2) + ' scanning wavelength'
  print, '  ' + strtrim(swvl/float(interferometer),2), ' FSR (A)'
  print, '  ' + strtrim(299792.458/float(interferometer),2), ' FSR (km/s)'
  print, '  ' + strtrim(swvl/float(interferometer)/float(zxy[0]),2), ' step (A)'
  print, '  ' + strtrim(long(max(cycles)),2) + ' cycles'
  print, '  ' + strtrim(long(zxy[0]),2) + ' channels'
  print, '  ' + strtrim(long(max(exposure)),2) + ' seconds per channel'
  tint = max(cycles)*zxy[0]*max(exposure)
  print, '  ' + strtrim(long(tint),2) + ' seconds total integration time (' + strtrim(tint/60.0,2) + ' minutes)'
  print, '  ' + strtrim(tint/float(zxy[0]),2) + ' seconds total time per channel (' + strtrim(tint/(60.0*zxy[0]),2) + ' minutes)'
  print, '  ' + strtrim(mean(efficiency),2) + ' mean efficiency'
  print, '  ' + strtrim(long(tint*mean(efficiency)),2) + ' seconds effective integration time (' + strtrim(tint/60.0*mean(efficiency),2) + ' minutes)'
  print, '  ' + strtrim(tint*mean(efficiency)/float(zxy[0]),2) + ' seconds effective time per channel (' + strtrim(tint/60.0*mean(efficiency)/float(zxy[0]),2) + ' minutes)'
  print, '  Fitler: ' + filter


  popd
end
