function readAd2, filename, trailer
COMPILE_OPT IDL2
ON_ERROR, 2

  if n_params() eq 0 then begin
    print, 'Syntax:   readAd2(filename, trailer)'
    print, 'filename - ad2 file to read'
    print, ' trailer - array to put ad3 trailer'

    return, -1
  endif

  realfilename = filename

  info = file_info(realfilename)

  testgz = strsplit(realfilename, '.', /extract)
  testgz = testgz[n_elements(testgz)-1]

  if (info.exists eq 0) or (info.read eq 0) or (testgz eq 'gz') then begin
    ; On regarde si plutot le fichier est .ad3.gz...
    if (testgz ne 'gz') then begin
      realfilename = filename + '.gz'
      info = file_info(realfilename)
    endif else begin
      realfilename = filename
    endelse

    if (info.exists eq 0) or (info.read eq 0) then return, -1
    if (!version.os_family ne 'unix') then return, -1

    testgz = 'gz'

    openr, unit, realfilename, /get_lun, /compress, /swap_if_big_endian

    spawn, 'gzip -l ' + realfilename, output
    output = strsplit(output[1], ' ', /extract)
    size = ulong64(output[1])
  endif else begin
    openr, unit, realfilename, /get_lun, /swap_if_big_endian
    size = info.size
  endelse

  data = fltarr((size-256)/4, /nozero)

  readu, unit, data

  trailer = {ad2_trailer}

  readu, unit, trailer

  if (trailer.lx ge 32768) or (trailer.ly ge 32768) then begin
    print, 'Error: lx or ly seems to be invalid: (' + strtrim(trailer.lx,2) + ', ' + strtrim(trailer.ly,2) + ')'
    print, 'If you want to allow arrays as large as this, modify the code!'
    return, -1
  endif

  data = reform(data, trailer.lx, trailer.ly)

  free_lun, unit

  if testgz eq 'gz' then begin
    trailer.was_compressed = 1
  endif

  return, data

end
