function readada, ada, xsize, ysize, efficiency, nphotons, silent=sil
COMPILE_OPT IDL2
ON_ERROR, 2

  if n_elements(sil) eq 0 then sil = 0

  if n_elements(efficiency) eq 0 then efficiency=1.0
  if n_elements(efficiency) ne n_elements(ada) then begin
    if sil eq 0 then begin
      print, 'Warning! n_elements(efficiency) ne n_elements(ada) (' + strtrim(n_elements(efficiency),2) + ', ' + strtrim(n_elements(ada),2) + ')'
    endif
    efficiency = replicate(efficiency[0], n_elements(ada))
  endif

  temp = fltarr(xsize, ysize)
  nphotons = 0

  for i=0, n_elements(ada)-1 do begin
  
    info = file_info(ada[i])

    if (info.exists eq 0) or (info.read eq 0) then continue
  
    if (info.size eq 0) then continue

    openr, unit, ada[i], /get_lun, /swap_if_big_endian

    np = info.size/4
;    print, np

    nphotons = nphotons + np

    data = uintarr(2, np)

    point_lun, unit, 0

    readu, unit, data

    free_lun, unit

    data[1,*] = data[1,*] < (xsize-1)
    data[0,*] = data[0,*] < (ysize-1)
    data = data > 0

    count = 1.0/efficiency[i]

    for j=0, np-1 do begin
      temp[data[1,j], data[0,j]] = temp[data[1,j], data[0,j]]+count
;      print, data[1,j], data[0,j]
    endfor
  endfor

  return, temp

end
