; Threshold: vitesse a partir de laquelle on considere un interfringe
; Si shift est negatif, c'est la vitesse maximale de l'interfringe
; Si shift est positif, c'est la vitesse minimale de l'interfringe

function interFringe, rv, zone, threshold, shift, binnum=binnum
COMPILE_OPT IDL2, HIDDEN

  sz = size(rv)
  mask = bytarr(sz[1], sz[2])

  for i=0, n_elements(zone)-1 do begin
    mask[zone[i].x1:zone[i].x2, zone[i].y1:zone[i].y2] = 1
  endfor


  if n_elements(binnum) eq n_elements(rv) then begin
    b = binnum[where(mask ne 0)]
    start = min(b)
    go = 1
    while go eq 1 do begin
      idx = where(binnum eq start)
      ; Des qu'une zone d'interfrange touche
      ; au bin, on considere que tout le bin est dedans
      mask[idx] = 1
      idx = where(b eq start)
      if n_elements(idx) eq n_elements(b) then go=0 else  remove, idx, b
      start = min(b)        
    endwhile
  endif

  idx = where(mask ne 0)
  small = rv[idx]

  if shift lt 0 then begin
    toshift = where(small gt threshold)
  endif else begin
    toshift = where(small lt threshold)
  endelse

  if toshift[0] ne -1 then begin
    small[toshift] = small[toshift] + shift
  endif

  rv[idx] = small

  return, rv

;  for i=0, n_elements(zone)-1 do begin
;    small = rv[zone[i].x1:zone[i].x2, zone[i].y1:zone[i].y2]
;
;    if shift lt 0 then begin
;      toshift = where(small gt threshold)
;    endif else begin
;      toshift = where(small lt threshold)
;    endelse
;
;    if toshift[0] ne -1 then begin
;      small[toshift] = small[toshift] + shift
;    endif
;
;    rv[zone[i].x1:zone[i].x2, zone[i].y1:zone[i].y2] = small
;  endfor

  return, rv

end



function resolveInterfringe, rv, adz, trailer, direction, binnum=binnum
COMPILE_OPT IDL2, HIDDEN

  ; We support interfringe in the range of 1 only...
  if n_elements(direction) eq 0 then direction = 1.0
  if direction ge 0 then direction = 1.0
  if direction lt 0 then direction = -1.0

  shift = trailer.xik ; Interfringe value taken from ad3 trailer
;  threshold = trailer.vr1 + trailer.xi1/2.0

  c = 299792.458D

  z = ((trailer.xl1 + trailer.xi1/2) / trailer.xl0) - 1
  threshold = ((z + 1)^2 - 1)/((z + 1)^2 + 1) * c + trailer.corrv

  print, threshold, shift*direction

  rvshift = rv

;  if (adz.x1 ne adz.x2) and (adz.y1 ne adz.y2) then begin
    rvshift = interfringe(rvshift, adz, threshold, shift*direction, binnum=binnum)
;  endif
  
  return, rvshift

end
