; Threshold: vitesse a partir de laquelle on considere un interfringe
; Si shift est negatif, c'est la vitesse maximale de l'interfringe
; Si shift est positif, c'est la vitesse minimale de l'interfringe

function interFringeCube, cube, bottom, zsize, zone, shift, binnum=binnum
COMPILE_OPT IDL2, HIDDEN

  sz = size(cube)
  threshold = zsize/2

  mask = bytarr(sz[2], sz[3])
  map = fltarr(sz[2], sz[3])

  for x=0, sz[2]-1 do begin
    for y=0, sz[3]-1 do begin
      map[x,y] = (baryc(cube[bottom:bottom+zsize-1,x,y]))[0]
    endfor
  endfor

  for i=0, n_elements(zone)-1 do begin
    mask[zone[i].x1:zone[i].x2, zone[i].y1:zone[i].y2] = 1
  endfor

  if n_elements(binnum) eq (sz[2]*sz[3]) then begin
    b = binnum[where(mask ne 0)]
    start = min(b)
    go = 1
    while go eq 1 do begin
      idx = where(binnum eq start)
      ; Des qu'une zone d'interfrange touche
      ; au bin, on considere que tout le bin est dedans
      mask[idx] = 1
      idx = where(b eq start)
      if n_elements(idx) eq n_elements(b) then go=0 else  remove, idx, b
      start = min(b)        
    endwhile
  endif

  idx = where(mask ne 0)
  small = map[idx]

  if shift lt 0 then begin
    toshift = where(small gt threshold)
    ind = array_indices(mask, idx[toshift])
    for i=0, n_elements(toshift)-1 do begin
      raietemp = cube[bottom:bottom+zsize-1,ind[0,i],ind[1,i]]
      cube[bottom+shift:bottom+zsize+shift-1,ind[0,i],ind[1,i]] = raietemp
      cube[bottom+zsize/2:sz[1]-1,ind[0,i],ind[1,i]] = (baryc(raietemp))[3]
    endfor
  endif else begin
    toshift = where(small lt threshold)
    ind = array_indices(mask, idx[toshift])
    for i=0, n_elements(toshift)-1 do begin
      raietemp = cube[bottom:bottom+zsize-1,ind[0,i],ind[1,i]]
      cube[bottom+shift:bottom+zsize+shift-1,ind[0,i],ind[1,i]] = raietemp
      cube[0:bottom+zsize/2-1,ind[0,i],ind[1,i]] = (baryc(raietemp))[3]
    endfor
  endelse

  return, cube

;  for i=0, n_elements(zone)-1 do begin
;    small = rv[zone[i].x1:zone[i].x2, zone[i].y1:zone[i].y2]
;
;    if shift lt 0 then begin
;      toshift = where(small gt threshold)
;    endif else begin
;      toshift = where(small lt threshold)
;    endelse
;
;    if toshift[0] ne -1 then begin
;      small[toshift] = small[toshift] + shift
;    endif
;
;    rv[zone[i].x1:zone[i].x2, zone[i].y1:zone[i].y2] = small
;  endfor

  return, rv

end



function resolveInterfringeCube, cube, adzlow, adzhigh, binnum=binnum
COMPILE_OPT IDL2, HIDDEN

  sz = size(cube)

  bottom = 0

  if (n_elements(adzlow) ne 0) and (n_elements(adzhigh) ne 0) then begin
    bottom = sz[1]
    temp = fltarr(sz[1]*3, sz[2], sz[3])
    temp[0:bottom-1,*,*] = cube
    temp[bottom:bottom+sz[1]-1,*,*] = cube
    temp[bottom+sz[1]:bottom+2*sz[1]-1,*,*] = cube
;    for x=0, sz[2]-1 do begin
;      for y=0, sz[3]-1 do begin
;        cont = (baryc(cube[*,x,y]))[3]
;        temp[0:bottom-1,x,y] = cont
;        temp[bottom+sz[1]:bottom+2*sz[1]-1,x,y] = cont
;      endfor
;    endfor
  endif

  if (n_elements(adzlow) ne 0) and (n_elements(adzhigh) eq 0) then begin
    bottom = sz[1]
    temp = fltarr(sz[1]*2, sz[2], sz[3])
    temp[bottom:bottom+sz[1]-1,*,*] = cube
    temp[0:bottom-1,*,*] = cube
;    for x=0, sz[2]-1 do begin
;      for y=0, sz[3]-1 do begin
;        temp[0:bottom-1,x,y] = (baryc(cube[*,x,y]))[3]
;      endfor
;    endfor
  endif

  if (n_elements(adzlow) eq 0) and (n_elements(adzhigh) ne 0) then begin
    bottom = 0
    temp = fltarr(sz[1]*2, sz[2], sz[3])
    temp[bottom:bottom+sz[1]-1,*,*] = cube
    temp[bottom+sz[1]:bottom+2*sz[1]-1,*,*] = cube
;    for x=0, sz[2]-1 do begin
;      for y=0, sz[3]-1 do begin
;        temp[bottom+sz[1]:bottom+sz[1]*2-1,x,y] = (baryc(cube[*,x,y]))[3]
;      endfor
;    endfor
  endif

;  if n_elements(adzlow) ne 0 then begin
;    temp = interfringeCube(temp, bottom, sz[1], adzlow, sz[1]*(-1), binnum=binnum)
;  endif

;  if n_elements(adzhigh) ne 0 then begin
;    temp = interfringeCube(temp, bottom, sz[1], adzhigh, sz[1], binnum=binnum)
;  endif

  return, temp
end
