pro testSn, file, range=range

  if n_elements(range) eq 0 then range = 1

  loadct, 3

  if n_elements(file) eq 0 then file='lambda-adhoc-SZ1-OH-g6xy.ad3'
  cube = readad3(file)
;  cube = readfits(file)

;  cube = readad3('/home/odaigle/observations/reduction/ngc5194-1/lambda-binned-sn20-aligned.ad3', 20, xyz=0)
;cube = readad3('/home/odaigle/observations/reduction/ngc5194-1/lambda-OH-g6xy.ad3')
;cube = readad3('/home/odaigle/observations/reduction/ngc5194-1/lambda.ad3')
;cube = readad3('/home/odaigle/observations/reduction/ngc5194-1/lambda-OH-aligned-SZ2-sn20.ad3')
;cube = readad3('/home/odaigle/observations/reduction2/ngc5194-1/lambda-SZ1-aligned.ad3')
;cube = readad3('/home/odaigle/observations/reduction/ngc5194-1/lambda-OH-SZ2-aligned.ad3')
;cube = readad3('/home/odaigle/observations/reduction/V257/calibration.ad3')
;cube = readad3('/home/odaigle/observations/reduction/ngc5194-1/calibration.ad3', xyz=0)
;  ciel = adzToSkyZone(readAdz('/home/odaigle/observations/reduction/ngc5194-1/ciel.adz'))
;  cube = alignLines(cube, ciel, offset, raw=centrepos)
;  cube = substractSky(cube, spectrum=iciel)

;  cube = readad3('lamb1_org.ad3')

  sz = size(cube)

  window, 0, xsize=sz[2], ysize=sz[3]
  window, 1, xsize=1400, ysize=512

  tvset, 0
  tvscl, rescale(total(cube,1), 0.01, 0.99)
  loadct, 13

  for i=0, 100 do begin
    tvset, 0
    cursor, x, y, /device, /up
    print, x, y

    if range gt 1 then begin
      raie = cube[*, (x-range)>0:(x+range)<sz[2], (y-range)>0:(y+range)<sz[3]]
      raie = total(total(raie,2),2)
    endif else begin
      raie = cube[*, x, y]
    endelse

    output = baryc(raie)
    toto = writead1('raie.ad1', raie)
    print, 'Barycentre: ', [output[0], output[1]]
    print, 'Flux, continum: ', output[2], output[3]
    print, 'FWHM, HM: ', output[5], output[6]
    print, 'Dispersion, S/N dispersion: ', output[4], output[2]/(output[4]*output[4])
    
    sn = computeSignalNoiseValue(raie, signal, noise, flux, continum, b, start, stop, raiet, dispersion)
    print, sn
    print, baryc(raie)
    tvset, 1

;    print, signal, noise, sn, start, stop, x, y

    plot, raie, xtitle='Canaux', ytitle='Photons', yrange=[min(raie), max(raie)+2], xrange=[0, sz[1]-0.5], psym=10, xstyle=1
    xyouts, 100, 450, 'S/N: ' + strtrim(sn,2), /device
;    xyouts,5, max(cube[*,x,y])-(max(cube[*,x,y])/10)>1, 'S/Nd: ' + strtrim(signal/noise,2)
;    xyouts,5, max(cube[*,x,y])-(max(cube[*,x,y])/20)>0.5, 'Disp: ' + strtrim(output[4],2)
    oplot, findgen(sz[1]), replicate(continum+dispersion, sz[1]), linestyle=1
    oplot, findgen(sz[1]), replicate(continum-dispersion, sz[1]), linestyle=1
    oplot, findgen(sz[1]), replicate(continum, sz[1])
;    oplot, findgen(sz[1]), replicate(output[9]+output[2], sz[1])
    oplot, [b[0]], [b[1]+continum], psym=1
;    oplot, [b[0]], [b[1]+continum], psym=1, color=120
    oplot, replicate(start, 2), [0,max(raie)], linestyle=1
    oplot, replicate(stop, 2), [0,max(raie)], linestyle=1

    fit = gaussfit(findgen(sz[1]*10)/10, congrid(raie, sz[1]*10), a, nterms=4, sigma=sigma)
;    print, 'Resultats du fit ', a
;    print, '  fwhm: ', 2*sqrt(2*alog(2))*a[2]
    oplot, findgen(sz[1]*10)/10, fit, color=120
    oplot, [a[1]], [a[3]+a[0]/2], color=120, psym=1

    fit = makeGaussian([2*output[1], output[0], output[5]/(2*sqrt(2*alog(2))), output[3]], findgen(sz[1]*10)/10)
    oplot, findgen(sz[1]*10)/10, fit
  endfor


end
