pro updateAdCoordinatesFromFits, fitsfile

  if n_elements(fitsfile) eq 0 then begin
    print, 'No input file specified... Trying with position.fits'
    fitsfile = 'position.fits'
  endif

  im = readfits(fitsfile, hdr)

  if (n_elements(im) eq 0) and (im[0] eq -1) then begin
    print, 'Unable to read ' + fitsfile
    return
  endif

  gzfiles = findfile('*.ad3.gz')
  if gzfiles[0] ne '' then begin
    for i=0, n_elements(gzfiles)-1 do begin
      spawn, 'gzip -lv ' + gzfiles[i], out
      out = out[1]
      out = strsplit(out, ' ', /extract)
;      info = file_info(
      print, 'Touching ' + gzfiles[i]
      spawn, 'touch --date="' + out[2] + ' ' + out[3] + ' ' + out[4] + '" ' + gzfiles[i]
    endfor
  endif
  
  files = file_search('*.ad[23]')
  files2 = file_search('*.ad3.gz')

  if files2[0] ne '' then files = [files, files2]

  info = file_info(files)

  trailer = readAdTrailer(files[0])
  trailer = fitsHeaderToAdTrailer(hdr, trailer)

  for i=0, n_elements(files)-1 do begin
    time = systime(0, info[i].mtime)
    print, 'Processing file ' + files[i]
    tr = readAdTrailer(files[i])
    copyAdCoordinates, trailer, tr
    toto = writeAdTrailer(files[i], tr, time)
    spawn, 'touch --date="' + time + '" ' + files[i]
  endfor

end
