function writeAd1, filename, data
COMPILE_OPT IDL2
ON_ERROR, 2

  if n_params() eq 0 then begin
    print, 'Syntax: writeAd1(filename, data)'
    print, 'filename - ad1 file to write to'
    print, '    data - data cube to write'
    return, -1
  endif

  info = file_info(filename)

  if (info.exists eq 1) and (info.write eq 0) then return, -1

  openw, unit, filename, /get_lun

  if (n_elements(unit) eq 0) then return, -1

  for i=0, n_elements(data)-1 do begin
    printf, unit, strtrim(i,2), float(data[i])
  endfor

  free_lun, unit

  return, 0

end
